<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { CtfCardGroup } from '~/models';

export default Vue.extend({
  name: 'SupportCardGroup',
  props: {
    data: {
      type: Object as PropType<CtfCardGroup>,
      required: true,
    },
  },
});
</script>

<template>
  <div class="card-group">
    <SlpContainer>
      <div class="support-section-icon slp-mb-16">
        <SlpIcon size="xl" :icon="data.icon" />
      </div>
      <SlpRow>
        <SlpColumn :cols="6">
          <SlpTypography v-if="data.header" tag="h2" variant="heading2-bold">
            {{ data.header }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <div class="card-group__group">
        <div
          v-for="card in data.cards"
          :key="card"
          class="card-group__card"
          :class="card.class"
        >
          <div class="card-group__card-title">
            <SlpTypography v-if="card.title" tag="h3" variant="heading5-bold">
              {{ card.title }}
            </SlpTypography>
          </div>
          <div class="card-group__row">
            <SlpRow>
              <SlpColumn
                :cols="card?.column2Description ? 6 : 12"
                class="card-group__col"
              >
                <div
                  v-if="card?.description"
                  class="support-section-content"
                  v-html="$md.render(card?.description)"
                ></div>
              </SlpColumn>
              <SlpColumn
                v-if="card?.column2Description"
                :cols="6"
                class="card-group__col"
              >
                <div
                  class="support-section-content"
                  v-html="$md.render(card?.column2Description)"
                ></div>
              </SlpColumn>
            </SlpRow>
          </div>
          <div v-if="card.button" class="card-group__cta">
            <SlpButton
              variant="tertiary"
              class="card__link"
              :href="card.button?.fields?.externalUrl"
              :data-ga-name="card.button?.fields?.dataGaName"
              :data-ga-location="card.button?.fields?.dataGaLocation"
            >
              {{ card.button.fields?.text }}
              <SlpIcon name="chevron-right" variant="product" />
            </SlpButton>
          </div>
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.card-group {
  &__group {
    display: grid;
    grid-template-columns: repeat(1, 1fr);
    grid-column-gap: 30px;
    grid-row-gap: 32px;
    margin-top: 32px;
    @media (min-width: $breakpoint-md) {
      margin-top: 64px;
      grid-row-gap: 64px;
      grid-template-columns: repeat(3, 1fr);
    }
    & > :nth-child(1),
    & > :nth-child(5n) {
      @media (min-width: $breakpoint-md) {
        grid-column: 1 / span 3;
      }

      .card-group__card-title,
      .card-group__col {
        padding: 32px 48px;
      }
    }
  }
  &__row {
    :deep {
      ul {
        list-style-type: disc;
        li {
          margin: 24px 0px 0px 24px;
          padding-left: 4px;
        }
      }
    }
  }
  &__card {
    border: 1px solid $color-surface-200;
    border-radius: 12px;
    overflow: hidden;
  }
  &__card-title {
    background-color: $color-surface-800;
    padding: 32px;
    border-bottom: 1px solid $color-surface-200;
  }
  &__col {
    padding: 24px 32px;
    + .card-group__col {
      border-left: 1px solid $color-surface-200;
    }
  }
  &__cta {
    border-top: 1px solid $color-surface-200;
    padding: 32px 48px;
    background-color: $color-surface-100;
  }
}
.support-section-icon {
  background: linear-gradient(89deg, #eee7fd 3.12%, #ffe6e9 111.93%);
  border-radius: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  height: 96px;
  width: 96px;
  padding: 16px;
  &:deep {
    .slp-icon {
      width: 100%;
      height: 100%;
    }
  }
}
.support-list {
  &:deep(ul) {
    list-style-type: none;
    margin: 16px 0;

    li {
      margin: 0 auto !important;
      padding: 24px 0 24px 56px;
      position: relative;

      &:before {
        content: '';
        position: absolute;
        top: 24px;
        left: 0;
        border-radius: 100%;
        border: 1px solid $color-accent-400;

        display: block;
        width: 30px;
        height: 30px;
      }
      &:after {
        content: 'X';
        color: $color-accent-400;
        position: absolute;
        top: 24px;
        left: 0;
        width: 30px;
        height: 30px;
        text-align: center;
        justify-content: center;
        display: flex;
        align-items: center;
        line-height: 0;
        transform: scaleX(1.4);
        font-size: 12px;
      }
    }
  }
}
.support-section-content {
  :deep {
    p {
      margin: 16px auto;
      &:last-of-type {
        margin-bottom: 0;
      }
      &:first-of-type {
        margin-top: 0;
      }
    }
  }
}
</style>
